From 96a826b8f09f4064642aaca2d125a9d2e4554267 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 04 2020 07:17:12 +0000
Subject: [PATCH 523/2232] Check function signature restrictions in a more appropriate place


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 0ea53df..5d442ce 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -55,15 +55,6 @@ fn do_typecheck(cx: &mut Check) {
             _ => {}
         }
     }
-
-    for api in cx.apis {
-        if let Api::CxxFunction(efn) = api {
-            check_mut_return_restriction(cx, efn);
-        }
-        if let Api::CxxFunction(efn) | Api::RustFunction(efn) = api {
-            check_multiple_arg_lifetimes(cx, efn);
-        }
-    }
 }
 
 impl Check<'_> {
@@ -282,6 +273,12 @@ fn check_api_fn(cx: &mut Check, efn: &ExternFn) {
             cx.error(ty, "returning a function pointer is not implemented yet");
         }
     }
+
+    if efn.lang == Lang::Cxx {
+        check_mut_return_restriction(cx, efn);
+    }
+
+    check_multiple_arg_lifetimes(cx, efn);
 }
 
 fn check_mut_return_restriction(cx: &mut Check, efn: &ExternFn) {

